# MD for: https://www.mercadopago.com.br/developers/es/docs/checkout-api-payments/integration-configuration/other-payment-methods.md \# Other payment methods With Mercado Pago's Checkout Transparente, it is possible to offer, in addition to card and Pix, \*\*payments via boleto bancário\*\*. > NOTE > > In addition to the options available in this documentation, it is also possible to integrate \*\*other payment methods\*\* using the \*\*Payment Brick\*\*. Check \[Default rendering\](https://www.mercadopago.com.br/developers/en/docs/checkout-bricks/payment-brick/default-rendering#editor\_2) documentation of Payment for more details. To get a detailed list of all payment methods available for integration, send a \*\*GET\*\* with your \*\*Access token\*\* to the endpoint \[/v1/payment\_methods\](https://www.mercadopago.com.br/developers/en/reference/online-payments/checkout-api-payments/payment-methods/get) and run the request or, if you prefer, make the request using the SDKs below. * [csharp ](#editor%5F5) * [curl ](#editor%5F7) * [java ](#editor%5F3) * [node ](#editor%5F2) * [php ](#editor%5F1) * [python ](#editor%5F6) * [ruby ](#editor%5F4) php node java ruby csharp python curl ``` get(); ?> ``` Copiar ``` import { MercadoPagoConfig, PaymentMethods } from 'mercadopago'; const client = new MercadoPagoConfig({ accessToken: 'access_token' }); const paymentMethods = new PaymentMethods(client); paymentMethods.get().then((result) => console.log(result)) .catch((error) => console.log(error)); ``` Copiar ``` MercadoPagoConfig.setAccessToken("ENV_ACCESS_TOKEN"); PaymentMethodClient client = new PaymentMethodClient(); client.list(); ``` Copiar ``` require 'mercadopago' sdk = Mercadopago::SDK.new('ENV_ACCESS_TOKEN') payment_methods_response = sdk.payment_methods.get() payment_methods = payment_methods_response[:response] ``` Copiar ``` using MercadoPago.Client.PaymentMethod; using MercadoPago.Config; using MercadoPago.Resource; using MercadoPago.Resource.PaymentMethod; MercadoPagoConfig.AccessToken = "ENV_ACCESS_TOKEN"; var client = new PaymentMethodClient(); ResourcesList paymentMethods = await client.ListAsync(); ``` Copiar ``` import mercadopago sdk = mercadopago.SDK("ACCESS_TOKEN") payment_methods_response = sdk.payment_methods().list_all() payment_methods = payment_methods_response["response"] ``` Copiar ``` curl -X GET \ -H 'accept: application/json' \ -H 'content-type: application/json' \ -H 'Authorization: Bearer ENV_ACCESS_TOKEN' \ 'https://api.mercadopago.com/v1/payment_methods' \ ``` Copiar To offer \*\*Boleto Bancário\*\*, follow the steps below. ## Import MercadoPago.js To perform the Checkout Transparente integration, you need to capture the necessary data to process the payment. This capture is made by including the MercadoPago.js library in your project, followed by the payment form. Use the code below to import the library before adding the payment form. * [bash ](#editor%5F9) * [html ](#editor%5F8) html bash ``` ``` Copiar ``` npm install @mercadopago/sdk-js ``` Copiar \## Configure credentials Credentials are unique passwords with which we identify an integration in your account. They are made to capture payments in virtual stores and other applications securely. This is the first step of a complete code structure that must be followed for the correct integration of the payment flow. Pay attention to the blocks below to add to the codes as indicated. * [html ](#editor%5F10) * [javascript ](#editor%5F11) html javascript ``` ``` Copiar ``` import { loadMercadoPago } from "@mercadopago/sdk-js"; await loadMercadoPago(); const mp = new window.MercadoPago("YOUR_PUBLIC_KEY"); ``` Copiar \## Add payment form With the MercadoPago.js library included, add the payment form below to your project to ensure the secure capture of buyer data. In this step, it is important to use the list you consulted to obtain the available payment methods to create the payment options you want to offer. > WARNING > > When setting up payments with boleto bancário, it is mandatory that the \`zip\_code\`, \`street\_name\`, \`street\_number\`, \`neighborhood\`, \`city\` and \`federal\_unit\` fields are present in the payment form, and that the buyer fill them out correctly. If you have already made a configuration without these fields in it, you must update it to make sure your payments get processed correctly. * [html ](#editor%5F12) html ```

Payer Request


``` Copiar \## Get document types After configuring the credential, it is necessary to obtain the types of documents that will be part of filling out the payment form. By including the element of type \`select\` with the id: \`id = docType\` that is on the form, it will be possible to automatically fill in the available options when calling the following function: * [javascript ](#editor%5F13) javascript ``` (async function getIdentificationTypes() { try { const identificationTypes = await mp.getIdentificationTypes(); const identificationTypeElement = document.getElementById('form-checkout__identificationType'); createSelectOptions(identificationTypeElement, identificationTypes); } catch (e) { return console.error('Error getting identificationTypes: ', e); } })(); function createSelectOptions(elem, options, labelsAndKeys = { label: "name", value: "id" }) { const { label, value } = labelsAndKeys; elem.options.length = 0; const tempOptions = document.createDocumentFragment(); options.forEach(option => { const optValue = option[value]; const optLabel = option[label]; const opt = document.createElement('option'); opt.value = optValue; opt.textContent = optLabel; tempOptions.appendChild(opt); }); elem.appendChild(tempOptions); } ``` Copiar \## Send payment When finalizing the inclusion of the payment form and obtaining the types of documents, it is necessary to forward the buyer's email, type and document number, the payment method used and the details of the amount to be paid using our Payments API or one of our SDKs. To configure payments with \*\*Boleto Bancário\*\*, send a \*\*POST\*\* with the parameters detailed in the tables below to the endpoint \[/v1/payments\](https://www.mercadopago.com.br/developers/en/reference/online-payments/checkout-api-payments/create-payment/post) and run the request or, if you prefer, use one of our SDKs below. > WARNING > > For this step, when making the request via API or SDKs, it is necessary to send your Private Key - Access token. For more information, go to \[Credentials\](https://www.mercadopago.com.br/developers/en/docs/checkout-api-payments/additional-content/your-integrations/credentials). In addition, sending the header \`X-Idempotency-Key\` with your idempotency key will be requested to ensure the execution and reexecution of requests without undesirable situations, such as duplicate payments, for example. * [csharp ](#editor%5F18) * [curl ](#editor%5F21) * [go ](#editor%5F20) * [java ](#editor%5F16) * [node ](#editor%5F15) * [php ](#editor%5F14) * [python ](#editor%5F19) * [ruby ](#editor%5F17) php node java ruby csharp python go curl ``` setCustomHeaders(["X-Idempotency-Key: "]); $payment = $client->create([ "transaction_amount" => (float) $_POST[''], "payment_method_id" => $_POST[''], "payer" => [ "email" => $_POST[''], "first_name" => $_POST[''], "last_name" => $_POST[''], "identification" => [ "type" => $_POST[''], "number" => $_POST[''] ], "address" => [ "zip_code" => $_POST[''], "city" => $_POST[''], "street_name" => $_POST[''], "street_number" => $_POST[''], "neighborhood" => $_POST[''], "federal_unit" => $_POST[''] ] ] ], $request_options); echo implode($payment); ?> ``` Copiar ``` import { MercadoPagoConfig, Payments } from 'mercadopago'; const client = new MercadoPagoConfig({ accessToken: '' }); const payments = new Payments(client); payments.create({ body: { transaction_amount: '', payment_method_id: '', payer: { email: '', first_name: '', last_name: '', identification:{ type:'', number:'' }, address:{ zip_code: '', city: '', neighborhood: '', street_name: '', street_number: '', federal_unit: '' } } }, requestOptions: { idempotencyKey: '' } }) .then((result) => console.log(result)) .catch((error) => console.log(error)); ``` Copiar ``` PaymentCreateRequest paymentCreateRequest = PaymentCreateRequest.builder() .transactionAmount(new BigDecimal("")) .paymentMethodId("bolbradesco") .payer(PaymentPayerRequest.builder() .email("") .firstName("") .lastName("") .identification(IdentificationRequest.builder() .type("CPF") .number("") .build()) .address(PaymentPayerAddressRequest.builder() .streetName("") .streetNumber("123") .zipCode("") .federalUnit("") .city("") .neighborhood("") .build()) .build()) .build(); ``` Copiar ``` require 'mercadopago' sdk = Mercadopago::SDK.new('ENV_ACCESS_TOKEN') custom_headers = { 'x-idempotency-key': '' } custom_request_options = Mercadopago::RequestOptions.new(custom_headers: custom_headers) payment_request = { transaction_amount: 100, description: 'Título del producto', payment_method_id: 'bolbradesco', payer: { email: 'PAYER_EMAIL', first_name: 'Test', last_name: 'User', identification: { type: 'DNI', number: '19119119', }, address: { zip_code: '1264', street_name: 'Av. Caseros', street_number: '3039', neighborhood: 'Parque Patricios', city: 'Buenos Aires', federal_unit: 'BA' } } } payment_response = sdk.payment.create(payment_request, custom_request_options) payment = payment_response[:response] ``` Copiar ``` MercadoPagoConfig.AccessToken = ""; var request = new PaymentCreateRequest { TransactionAmount = 105, Description = "", PaymentMethodId = "bolbradesco", Payer = new PaymentPayerRequest { Email = "", FirstName = "", LastName = "", Identification = new IdentificationRequest { Type = "CPF", Number = "", }, Address = new PaymentPayerAddressRequest { ZipCode = "", StreetName = "", City = "", StreetNumber = "", Neighborhood = "", FederalUnit = "", } }, }; var client = new PaymentClient(); Payment payment = await client.CreateAsync(request); ``` Copiar ``` import mercadopago sdk = mercadopago.SDK("ENV_ACCESS_TOKEN") request_options = mercadopago.config.RequestOptions() request_options.custom_headers = { 'x-idempotency-key': '' } payment_data = { "transaction_amount": 100, "description": "Título del producto", "payment_method_id": "bolbradesco", "payer": { "email": "PAYER_EMAIL", "first_name": "Test", "last_name": "User", "identification": { "type": "DNI", "number": "19119119" }, "address": { "zip_code": "1264", "street_name": "Av. Caseros", "street_number": "3039", "neighborhood": "Parque Patricios", "city": "Buenos Aires", "federal_unit": "BA" } } } payment_response = sdk.payment().create(payment_data, request_options) payment = payment_response["response"] ``` Copiar ``` accessToken := "{{ACCESS_TOKEN}}" cfg, err := config.New(accessToken) if err != nil { fmt.Println(err) return } client := payment.NewClient(cfg) request := payment.Request{ TransactionAmount: 105, PaymentMethodID: "bolbradesco", Payer: &payment.PayerRequest{ Email: "{{EMAIL}}", FirstName: "{{NOME}}", LastName: "{{SOBRENOME}}", Identification: &payment.IdentificationRequest{ Type: "{{TIPO DO DOCUMENTO}}", Number: "{{NUMERO}}", }, Address: &payment.AddressRequest{ ZipCode: "06233-200", City: "Osasco", Neighborhood: "Bonfim", StreetName: "Av. das Nações Unidas", StreetNumber: "3003", FederalUnit: "SP", }, }, } resource, err := client.Create(context.Background(), request) if err != nil { fmt.Println(err) return } fmt.Println(resource) ``` Copiar ``` curl --location 'https://api.mercadopago.com/v1/payments' \ --header 'Content-Type: application/json' \ --header 'Authorization: Bearer ENV_ACCESS_TOKEN' \ --header 'X-Idempotency-Key: ' \ --header 'X-Product-Id: ' \ --data-raw '{ "transaction_amount": 100, "description": "Titulo do produto", "payment_method_id": "bolbradesco", "payer": { "email": "test_payer@example.com", "first_name": "Test", "last_name": "User", "identification": { "type": "CPF", "number": "01234567890" } "address": { "zip_code": "88000000", "street_name": "Nombre de calle", "street_number": "123", "neighborhood": "Barrio", "city": "Ciudad", "federal_unit": "UF" } } }' ``` Copiar \#### - Mandatory fields for boleto bancário payments | Parameter | Type | Description, possible values and examples | |---|---|---| | \`payment\_method\_id\` | string | Payment method. For boleto bancário, it is always \`bolbradesco\`. | | \`address.zip\_code\` | string | Zip code. Example: 88000000 | | \`address.street\_name\` | string | Buyer's street name. Example: Rua da Abobrinha. | | \`address.street\_number\` | string | Buyer's address number. Example: 1291 If you do not have a number, send "\*\*S/N\*\*". | | \`address.neighborhood\` | string | Neighborhood where the buyer's address is located. Example: Copacabana. | | \`address.city\` | string | City where the buyer lives. Example: Rio de Janeiro. | | \`address.federal\_unit\` | string | State abbreviation where the buyer lives. Only two characters are accepted. For example: RJ. | #### - Mandatory fields for pagamentos em lotéricas | Parameter | Type | Description, possible values and examples | |---|---|---| | \`payment\_method\_id\` | string | Payment method. | > WARNING > > If you need additional information on how to send all the required fields in this request, please refer to the \[API Reference\](https://www.mercadopago.com.br/developers/en/reference/online-payments/checkout-api-payments/create-payment/post). The response will show the \`pending\` status until the buyer completes the payment. Also, in the response to the request, the \`external\_resource\_url\` parameter will return a URL that contains instructions for the buyer to make the payment. You can redirect to this same link to complete the payment flow. See below for an example return. * [json ](#editor%5F22) json ``` [ { ..., "id": 5466310457, "status": "pending", "status_detail": "pending_waiting_payment", ..., "transaction_details": { "net_received_amount": 0, "total_paid_amount": 100, "overpaid_amount": 0, "external_resource_url": "https://www.mercadopago.com/mla/payments/ticket/helper?payment_id=123456789&payment_method_reference_id= 123456789&caller_id=123456", "installment_amount": 0, "financial_institution": null, "payment_method_reference_id": "1234567890" } } ] ``` Copiar \> NOTE > > The customer has between 3 and 5 days to pay, depending on the payment method. After this time, the payment must be canceled. ## Expiration date The default expiration date for payments with boleto is 3 days. Optionally, it is possible to change this date by sending the \`date\_of\_expiration\` field in the payment creation request, defining a period between 1 and 30 days from the boleto issuance date. To change the expiration date, use one of the codes available below. * [csharp ](#editor%5F27) * [curl ](#editor%5F29) * [java ](#editor%5F25) * [node ](#editor%5F24) * [php ](#editor%5F23) * [python ](#editor%5F28) * [ruby ](#editor%5F26) php node java ruby csharp python curl The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` $payment->date_of_expiration = "2020-05-30T23:59:59.000-04:00"; ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` date_of_expiration: "2020-05-30T23:59:59.000-04:00", ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` payment.setDateOfExpiration("2020-05-30T23:59:59.000-04:00") ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` date_of_expiration: '2020-05-30T23:59:59.000-04:00', ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` paymentCreateRequest.DateOfExpiration = DateTime.Parse("2020-05-30T23:59:59.000-04:00"); ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` "date_of_expiration": "2020-05-30T23:59:59.000-04:00" ``` Copiar The date uses the ISO 8601 format: yyyy-MM-dd'T'HH:mm:ssz ``` "date_of_expiration": "2020-05-30T23:59:59.000-04:00", ``` Copiar The approval timeframe for the boleto is up to 2 business hours. Therefore, set the expiration date to a minimum of 3 days to ensure that the payment is made. > WARNING > > If the boleto is paid after the expiration date, the amount will be refunded to the payer's Mercado Pago account. ## Cancel payment To avoid billing issues, it is important to cancel overdue payments. Also, keep in mind that \*\*it is possible to cancel only payments that are pending or in process\*\*. If a payment is due within 30 days, the cancellation is automatic and the final status of the payment will be \`cancelled\` or \`expired\`. For more information, see the \[Refunds and Cancellations\](https://www.mercadopago.com.br/developers/en/docs/checkout-api-payments/payment-management/cancellations-and-refunds) section.